明经CAD社区

 找回密码
 注册

扫一扫,访问微社区

QQ登录

只需一步,快速开始

查看: 330|回复: 5

【求助】拷贝文字随线角度

[复制链接]
发表于 2018-1-5 16:03 | 显示全部楼层 |阅读模式
[code="lisp] ;;;拷贝文字随线角度 by x_s_s_1@163.com
(vl-load-com)
(defun c:ctb (/ ent enl pt1 pt2 mid_pt ang)
  (defun emk_t (layer pt1 pt2 text ang n72 n73 h w sty /)
    (entmake (list '(0 . "text")
     '(100 . "AcDbEntity")
     (cons 8 layer)
     '(100 . "AcDbText")
     (cons 10 pt1)
     (cons 1 text)
     (cons 40 h)
     (cons 41 w)
     (cons 7 sty)
     (cons 72 n72)
     (cons 11 pt2)
     (cons 50 ang)
     (cons 73 n73)
      )
    )
  )
  (setq ent (car (entsel "\n选择文字:")))
  (if (= "TEXT" (cdr (assoc 0 (entget ent))))
    (progn
      (while (setq enl (entsel "\n选择对齐线:"))
(if (= "LINE" (cdr (assoc 0 (entget (car enl)))))
   (progn
     (setq pt1  (cdr (assoc 10 (entget (car enl))))
    pt2  (cdr (assoc 11 (entget (car enl))))
    mid_pt (vlax-curve-getClosestPointTo
      (vlax-ename->vla-object (car enl))
      (cadr enl)
    )
    ang  (angle pt1 pt2)
     )
     (if (and (> ang (* 0.5 pi)) (<= ang (* pi 1.5)))
       (setq ang (- ang pi))
     )
     (emk_t (cdr (assoc 8 (entget ent)))
     '(0 0 0)
     (polar mid_pt (+ ang (* 0.5 pi)) 100)
     (cdr (assoc 1 (entget ent)))
     ang
     1
     0
     (cdr (assoc 40 (entget ent)))
     (cdr (assoc 41 (entget ent)))
     (cdr (assoc 7 (entget ent)))
     )
   )
)
      )
    )
  )
  (princ)
)[/code]



上面是网上看到的源代码,遇到的问题如下:
1.只能适用于直线,pl线等无法使用,如果调整可以适合其他线性
2.文字平行线性后,距离线太远,如何调整距离

发表于 2018-1-16 09:28 | 显示全部楼层
不好用~~~~~    文字乱跑~
发表于 2018-1-16 09:29 | 显示全部楼层
不过感谢分享源码,大神
发表于 2018-1-16 12:05 | 显示全部楼层
哥们,这个求助我已经发了两次了,还没有大神帮忙呢
发表于 2018-1-19 12:37 | 显示全部楼层
哥们,试试这个,应该可以帮到你,我就用的这个。

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
发表于 2018-1-19 12:38 | 显示全部楼层
要不再来一个吧,如何,里面数据可自己改一下

本帖子中包含更多资源

您需要 登录 才可以下载或查看,没有帐号?注册

x
您需要登录后才可以回帖 登录 | 注册

本版积分规则

小黑屋|手机版|CAD论坛|CAD教程|CAD下载|联系我们|关于明经|明经通道 ( 粤ICP备05003914号  
©2000-2017 明经通道 版权所有 本站代码,在未取得本站及作者授权的情况下,不得用于商业用途

GMT+8, 2018-10-19 23:35 , Processed in 0.234526 second(s), 28 queries , Gzip On.

Powered by Discuz! X3.3

© 2001-2013 Comsenz Inc.

快速回复 返回顶部 返回列表